# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from fetch_pbd_interaction/MoveArmRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import fetch_pbd_interaction.msg
import sensor_msgs.msg
import geometry_msgs.msg
import std_msgs.msg

class MoveArmRequest(genpy.Message):
  _md5sum = "c1bfe5af564aa6cd494ad9b96ec8163e"
  _type = "fetch_pbd_interaction/MoveArmRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """fetch_pbd_interaction/ArmState arm_state

================================================================================
MSG: fetch_pbd_interaction/ArmState
uint8 ROBOT_BASE=0
uint8 FIXED_LINK=1
uint8 PREVIOUS_TARGET=2
uint8 OBJECT=3
uint8 ref_type
geometry_msgs/PoseStamped ee_pose
float64[] joint_pose
float64[] velocities
Landmark ref_landmark
================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: fetch_pbd_interaction/Landmark
string name
geometry_msgs/Pose pose
geometry_msgs/Vector3 dimensions
sensor_msgs/PointCloud2 point_cloud
================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the "fields" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field
"""
  __slots__ = ['arm_state']
  _slot_types = ['fetch_pbd_interaction/ArmState']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       arm_state

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MoveArmRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.arm_state is None:
        self.arm_state = fetch_pbd_interaction.msg.ArmState()
    else:
      self.arm_state = fetch_pbd_interaction.msg.ArmState()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_B3I.pack(_x.arm_state.ref_type, _x.arm_state.ee_pose.header.seq, _x.arm_state.ee_pose.header.stamp.secs, _x.arm_state.ee_pose.header.stamp.nsecs))
      _x = self.arm_state.ee_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.arm_state.ee_pose.pose.position.x, _x.arm_state.ee_pose.pose.position.y, _x.arm_state.ee_pose.pose.position.z, _x.arm_state.ee_pose.pose.orientation.x, _x.arm_state.ee_pose.pose.orientation.y, _x.arm_state.ee_pose.pose.orientation.z, _x.arm_state.ee_pose.pose.orientation.w))
      length = len(self.arm_state.joint_pose)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.arm_state.joint_pose))
      length = len(self.arm_state.velocities)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.arm_state.velocities))
      _x = self.arm_state.ref_landmark.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_10d3I.pack(_x.arm_state.ref_landmark.pose.position.x, _x.arm_state.ref_landmark.pose.position.y, _x.arm_state.ref_landmark.pose.position.z, _x.arm_state.ref_landmark.pose.orientation.x, _x.arm_state.ref_landmark.pose.orientation.y, _x.arm_state.ref_landmark.pose.orientation.z, _x.arm_state.ref_landmark.pose.orientation.w, _x.arm_state.ref_landmark.dimensions.x, _x.arm_state.ref_landmark.dimensions.y, _x.arm_state.ref_landmark.dimensions.z, _x.arm_state.ref_landmark.point_cloud.header.seq, _x.arm_state.ref_landmark.point_cloud.header.stamp.secs, _x.arm_state.ref_landmark.point_cloud.header.stamp.nsecs))
      _x = self.arm_state.ref_landmark.point_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.arm_state.ref_landmark.point_cloud.height, _x.arm_state.ref_landmark.point_cloud.width))
      length = len(self.arm_state.ref_landmark.point_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.arm_state.ref_landmark.point_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.arm_state.ref_landmark.point_cloud.is_bigendian, _x.arm_state.ref_landmark.point_cloud.point_step, _x.arm_state.ref_landmark.point_cloud.row_step))
      _x = self.arm_state.ref_landmark.point_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.arm_state.ref_landmark.point_cloud.is_dense))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.arm_state is None:
        self.arm_state = fetch_pbd_interaction.msg.ArmState()
      end = 0
      _x = self
      start = end
      end += 13
      (_x.arm_state.ref_type, _x.arm_state.ee_pose.header.seq, _x.arm_state.ee_pose.header.stamp.secs, _x.arm_state.ee_pose.header.stamp.nsecs,) = _struct_B3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.arm_state.ee_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.arm_state.ee_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.arm_state.ee_pose.pose.position.x, _x.arm_state.ee_pose.pose.position.y, _x.arm_state.ee_pose.pose.position.z, _x.arm_state.ee_pose.pose.orientation.x, _x.arm_state.ee_pose.pose.orientation.y, _x.arm_state.ee_pose.pose.orientation.z, _x.arm_state.ee_pose.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.arm_state.joint_pose = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.arm_state.velocities = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.arm_state.ref_landmark.name = str[start:end].decode('utf-8')
      else:
        self.arm_state.ref_landmark.name = str[start:end]
      _x = self
      start = end
      end += 92
      (_x.arm_state.ref_landmark.pose.position.x, _x.arm_state.ref_landmark.pose.position.y, _x.arm_state.ref_landmark.pose.position.z, _x.arm_state.ref_landmark.pose.orientation.x, _x.arm_state.ref_landmark.pose.orientation.y, _x.arm_state.ref_landmark.pose.orientation.z, _x.arm_state.ref_landmark.pose.orientation.w, _x.arm_state.ref_landmark.dimensions.x, _x.arm_state.ref_landmark.dimensions.y, _x.arm_state.ref_landmark.dimensions.z, _x.arm_state.ref_landmark.point_cloud.header.seq, _x.arm_state.ref_landmark.point_cloud.header.stamp.secs, _x.arm_state.ref_landmark.point_cloud.header.stamp.nsecs,) = _struct_10d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.arm_state.ref_landmark.point_cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.arm_state.ref_landmark.point_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.arm_state.ref_landmark.point_cloud.height, _x.arm_state.ref_landmark.point_cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.arm_state.ref_landmark.point_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.arm_state.ref_landmark.point_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.arm_state.ref_landmark.point_cloud.is_bigendian, _x.arm_state.ref_landmark.point_cloud.point_step, _x.arm_state.ref_landmark.point_cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.arm_state.ref_landmark.point_cloud.is_bigendian = bool(self.arm_state.ref_landmark.point_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.arm_state.ref_landmark.point_cloud.data = str[start:end]
      start = end
      end += 1
      (self.arm_state.ref_landmark.point_cloud.is_dense,) = _struct_B.unpack(str[start:end])
      self.arm_state.ref_landmark.point_cloud.is_dense = bool(self.arm_state.ref_landmark.point_cloud.is_dense)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_B3I.pack(_x.arm_state.ref_type, _x.arm_state.ee_pose.header.seq, _x.arm_state.ee_pose.header.stamp.secs, _x.arm_state.ee_pose.header.stamp.nsecs))
      _x = self.arm_state.ee_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.arm_state.ee_pose.pose.position.x, _x.arm_state.ee_pose.pose.position.y, _x.arm_state.ee_pose.pose.position.z, _x.arm_state.ee_pose.pose.orientation.x, _x.arm_state.ee_pose.pose.orientation.y, _x.arm_state.ee_pose.pose.orientation.z, _x.arm_state.ee_pose.pose.orientation.w))
      length = len(self.arm_state.joint_pose)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.arm_state.joint_pose.tostring())
      length = len(self.arm_state.velocities)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.arm_state.velocities.tostring())
      _x = self.arm_state.ref_landmark.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_10d3I.pack(_x.arm_state.ref_landmark.pose.position.x, _x.arm_state.ref_landmark.pose.position.y, _x.arm_state.ref_landmark.pose.position.z, _x.arm_state.ref_landmark.pose.orientation.x, _x.arm_state.ref_landmark.pose.orientation.y, _x.arm_state.ref_landmark.pose.orientation.z, _x.arm_state.ref_landmark.pose.orientation.w, _x.arm_state.ref_landmark.dimensions.x, _x.arm_state.ref_landmark.dimensions.y, _x.arm_state.ref_landmark.dimensions.z, _x.arm_state.ref_landmark.point_cloud.header.seq, _x.arm_state.ref_landmark.point_cloud.header.stamp.secs, _x.arm_state.ref_landmark.point_cloud.header.stamp.nsecs))
      _x = self.arm_state.ref_landmark.point_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.arm_state.ref_landmark.point_cloud.height, _x.arm_state.ref_landmark.point_cloud.width))
      length = len(self.arm_state.ref_landmark.point_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.arm_state.ref_landmark.point_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.arm_state.ref_landmark.point_cloud.is_bigendian, _x.arm_state.ref_landmark.point_cloud.point_step, _x.arm_state.ref_landmark.point_cloud.row_step))
      _x = self.arm_state.ref_landmark.point_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.arm_state.ref_landmark.point_cloud.is_dense))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.arm_state is None:
        self.arm_state = fetch_pbd_interaction.msg.ArmState()
      end = 0
      _x = self
      start = end
      end += 13
      (_x.arm_state.ref_type, _x.arm_state.ee_pose.header.seq, _x.arm_state.ee_pose.header.stamp.secs, _x.arm_state.ee_pose.header.stamp.nsecs,) = _struct_B3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.arm_state.ee_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.arm_state.ee_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.arm_state.ee_pose.pose.position.x, _x.arm_state.ee_pose.pose.position.y, _x.arm_state.ee_pose.pose.position.z, _x.arm_state.ee_pose.pose.orientation.x, _x.arm_state.ee_pose.pose.orientation.y, _x.arm_state.ee_pose.pose.orientation.z, _x.arm_state.ee_pose.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.arm_state.joint_pose = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.arm_state.velocities = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.arm_state.ref_landmark.name = str[start:end].decode('utf-8')
      else:
        self.arm_state.ref_landmark.name = str[start:end]
      _x = self
      start = end
      end += 92
      (_x.arm_state.ref_landmark.pose.position.x, _x.arm_state.ref_landmark.pose.position.y, _x.arm_state.ref_landmark.pose.position.z, _x.arm_state.ref_landmark.pose.orientation.x, _x.arm_state.ref_landmark.pose.orientation.y, _x.arm_state.ref_landmark.pose.orientation.z, _x.arm_state.ref_landmark.pose.orientation.w, _x.arm_state.ref_landmark.dimensions.x, _x.arm_state.ref_landmark.dimensions.y, _x.arm_state.ref_landmark.dimensions.z, _x.arm_state.ref_landmark.point_cloud.header.seq, _x.arm_state.ref_landmark.point_cloud.header.stamp.secs, _x.arm_state.ref_landmark.point_cloud.header.stamp.nsecs,) = _struct_10d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.arm_state.ref_landmark.point_cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.arm_state.ref_landmark.point_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.arm_state.ref_landmark.point_cloud.height, _x.arm_state.ref_landmark.point_cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.arm_state.ref_landmark.point_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.arm_state.ref_landmark.point_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.arm_state.ref_landmark.point_cloud.is_bigendian, _x.arm_state.ref_landmark.point_cloud.point_step, _x.arm_state.ref_landmark.point_cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.arm_state.ref_landmark.point_cloud.is_bigendian = bool(self.arm_state.ref_landmark.point_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.arm_state.ref_landmark.point_cloud.data = str[start:end]
      start = end
      end += 1
      (self.arm_state.ref_landmark.point_cloud.is_dense,) = _struct_B.unpack(str[start:end])
      self.arm_state.ref_landmark.point_cloud.is_dense = bool(self.arm_state.ref_landmark.point_cloud.is_dense)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_IBI = struct.Struct("<IBI")
_struct_7d = struct.Struct("<7d")
_struct_10d3I = struct.Struct("<10d3I")
_struct_B = struct.Struct("<B")
_struct_B3I = struct.Struct("<B3I")
_struct_B2I = struct.Struct("<B2I")
_struct_2I = struct.Struct("<2I")
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from fetch_pbd_interaction/MoveArmResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class MoveArmResponse(genpy.Message):
  _md5sum = "358e233cde0c8a8bcfea4ce193f8fc15"
  _type = "fetch_pbd_interaction/MoveArmResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool success
"""
  __slots__ = ['success']
  _slot_types = ['bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       success

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MoveArmResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
    else:
      self.success = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_B.pack(self.success))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      self.success = bool(self.success)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_B.pack(self.success))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      self.success = bool(self.success)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_B = struct.Struct("<B")
class MoveArm(object):
  _type          = 'fetch_pbd_interaction/MoveArm'
  _md5sum = '1872cfe6f2adc595657aad90b69910f1'
  _request_class  = MoveArmRequest
  _response_class = MoveArmResponse
